2 # TopGit - A different patch queue manager
3 # (c) Petr Baudis <pasky@suse.cz> 2008
12 echo "${TG_RECURSIVE}tg: $*"
21 # cat_file TOPIC:PATH [FROM]
22 # cat the file PATH from branch TOPIC when FROM is empty.
23 # FROM can be -i or -w, than the file will be from the index or worktree,
24 # respectively. The caller should than ensure that HEAD is TOPIC, to make sense.
30 cat "$root_dir/${path#*:}"
33 # ':file' means cat from index
34 git cat-file blob
":${path#*:}"
37 git cat-file blob
"$path"
40 die
"Wrong argument to cat_file: '$2'"
45 # get tree for the committed topic
51 # get tree for the base
54 echo "refs/top-bases/$1"
57 # get tree for the index
63 # get tree for the worktree
66 i_tree
=$
(git write-tree
)
68 # the file for --index-output needs to sit next to the
70 : ${GIT_INDEX_FILE:="$git_dir/index"}
71 TMP_INDEX
="$(mktemp "${GIT_INDEX_FILE}-tg.XXXXXX
")"
72 git read-tree
-m $i_tree --index-output="$TMP_INDEX" &&
73 GIT_INDEX_FILE
="$TMP_INDEX" &&
74 export GIT_INDEX_FILE
&&
75 git
diff --name-only -z HEAD |
76 git update-index
-z --add --remove --stdin &&
82 # pretty_tree NAME [-b | -i | -w]
83 # Output tree ID of a cleaned-up tree without tg's artifacts.
84 # NAME will be ignored for -i and -w, but needs to be present
89 git ls-tree
--full-tree "$(get_tree_$source "$name")" |
90 awk -F ' ' '$2 !~ /^.top/' |
97 hook_call
="\"\$($tg --hooks-path)\"/$1 \"\$@\""
98 if [ -f "$git_dir/hooks/$1" ] &&
99 fgrep
-q "$hook_call" "$git_dir/hooks/$1"; then
100 # Another job well done!
103 # Prepare incantation
104 if [ -x "$git_dir/hooks/$1" ]; then
105 hook_call
="$hook_call"' || exit $?'
107 hook_call
="exec $hook_call"
109 # Don't call hook if tg is not installed
110 hook_call
="if which \"$tg\" > /dev/null; then $hook_call; fi"
111 # Insert call into the hook
115 [ ! -s "$git_dir/hooks/$1" ] ||
cat "$git_dir/hooks/$1"
116 } >"$git_dir/hooks/$1+"
117 chmod a
+x
"$git_dir/hooks/$1+"
118 mv "$git_dir/hooks/$1+" "$git_dir/hooks/$1"
121 # setup_ours (no arguments)
124 if [ ! -s "$git_dir/info/attributes" ] ||
! grep -q topmsg
"$git_dir/info/attributes"; then
126 echo ".topmsg merge=ours"
127 echo ".topdeps merge=ours"
128 } >>"$git_dir/info/attributes"
130 if ! git config merge.ours.driver
>/dev
/null
; then
131 git config merge.ours.name
'"always keep ours" merge driver'
132 git config merge.ours.driver
'touch %A'
136 # measure_branch NAME [BASE]
139 _bname
="$1"; _base
="$2"
140 [ -n "$_base" ] || _base
="refs/top-bases/$_bname"
141 # The caller should've verified $name is valid
142 _commits
="$(git rev-list "$_bname" ^"$_base" -- | wc -l)"
143 _nmcommits
="$(git rev-list --no-merges "$_bname" ^"$_base" -- | wc -l)"
144 if [ $_commits -gt 1 ]; then
149 echo "$_commits/$_nmcommits $_suffix"
152 # branch_contains B1 B2
153 # Whether B1 is a superset of B2.
156 [ -z "$(git rev-list --max-count=1 ^"$1" "$2" --)" ]
160 # Whether REF is a valid ref name
163 git rev-parse
--verify "$@" >/dev
/null
2>&1
167 # Whether BRANCH has a remote equivalent (accepts top-bases/ too)
170 [ -n "$base_remote" ] && ref_exists
"remotes/$base_remote/$1"
177 # use the merge base in case the base is ahead.
178 mb
="$(git merge-base "refs
/top-bases
/$_name" "$_name")";
180 test "$(git rev-parse "$mb^
{tree
}")" = "$(git rev-parse "$_name^
{tree
}")";
184 # Whether REF is a SHA1 (compared to a symbolic name).
187 [ "$(git rev-parse "$1")" = "$1" ]
190 # recurse_deps CMD NAME [BRANCHPATH...]
191 # Recursively eval CMD on all dependencies of NAME.
192 # CMD can refer to $_name for queried branch name,
193 # $_dep for dependency name,
194 # $_depchain for space-seperated branch backtrace,
195 # and the $_dep_is_tgish boolean.
196 # It can modify $_ret to affect the return value
197 # of the whole function.
198 # If recurse_deps() hits missing dependencies, it will append
199 # them to space-separated $missing_deps list and skip them.
200 # remote dependencies are processed if no_remotes is unset.
204 _name
="$1"; # no shift
207 _depsfile
="$(get_temp tg-depsfile)"
208 # If no_remotes is unset check also our base against remote base.
209 # Checking our head against remote head has to be done in the helper.
210 if test -z "$no_remotes" && has_remote
"top-bases/$_name"; then
211 echo "refs/remotes/$base_remote/top-bases/$_name" >>"$_depsfile"
214 # if the branch was annihilated, there exists no .topdeps file
215 if ! branch_annihilated
"$_name"; then
216 #TODO: handle nonexisting .topdeps?
217 git cat-file blob
"$_name:.topdeps" >>"$_depsfile";
222 if ! ref_exists
"$_dep" ; then
224 missing_deps
="$missing_deps $_dep"
229 ref_exists
"refs/top-bases/$_dep" ||
232 # Shoo shoo, keep our environment alone!
233 [ -z "$_dep_is_tgish" ] ||
234 (recurse_deps
"$_cmd" "$_dep" "$@") ||
239 missing_deps
="${missing_deps# }"
243 # branch_needs_update
244 # This is a helper function for determining whether given branch
245 # is up-to-date wrt. its dependencies. It expects input as if it
246 # is called as a recurse_deps() helper.
247 # In case the branch does need update, it will echo it together
248 # with the branch backtrace on the output (see needs_update()
249 # description for details) and set $_ret to non-zero.
250 branch_needs_update
()
253 if [ -n "$_dep_is_tgish" ]; then
254 if has_remote
"$_dep"; then
255 branch_contains
"$_dep" "refs/remotes/$base_remote/$_dep" || _dep_base_update
=%
257 # This can possibly override the remote check result;
258 # we want to sync with our base first
259 branch_contains
"$_dep" "refs/top-bases/$_dep" || _dep_base_update
=:
262 if [ -n "$_dep_base_update" ]; then
263 # _dep needs to be synced with its base/remote
264 echo "$_dep_base_update $_dep $_depchain"
266 elif [ -n "$_name" ] && ! branch_contains
"refs/top-bases/$_name" "$_dep"; then
267 # Some new commits in _dep
268 echo "$_dep $_depchain"
274 # This function is recursive; it outputs reverse path from NAME
275 # to the branch (e.g. B_DIRTY B1 B2 NAME), one path per line,
276 # inner paths first. Innermost name can be ':' if the head is
277 # not in sync with the base or '%' if the head is not in sync
278 # with the remote (in this order of priority).
279 # It will also return non-zero status if NAME needs update.
280 # If needs_update() hits missing dependencies, it will append
281 # them to space-separated $missing_deps list and skip them.
284 recurse_deps branch_needs_update
"$@"
287 # branch_empty NAME [-i | -w]
290 [ "$(pretty_tree "$1" -b)" = "$(pretty_tree "$1" ${2-})" ]
293 # list_deps [-i | -w]
294 # -i/-w apply only to HEAD
301 head="$(git symbolic-ref -q HEAD)" ||
304 git for-each-ref refs
/top-bases |
305 while read rev type ref
; do
306 name
="${ref#refs/top-bases/}"
307 if branch_annihilated
"$name"; then
312 [ "refs/heads/$name" = "$head" ] ||
314 cat_file
"$name:.topdeps" $from |
while read dep
; do
316 ref_exists
"refs/top-bases/$dep" ||
318 if ! "$dep_is_tgish" ||
! branch_annihilated
$dep; then
325 # switch_to_base NAME [SEED]
328 _base
="refs/top-bases/$1"; _seed
="$2"
329 # We have to do all the hard work ourselves :/
330 # This is like git checkout -b "$_base" "$_seed"
331 # (or just git checkout "$_base"),
332 # but does not create a detached HEAD.
333 git read-tree
-u -m HEAD
"${_seed:-$_base}"
334 [ -z "$_seed" ] || git update-ref
"$_base" "$_seed"
335 git symbolic-ref HEAD
"$_base"
338 # Show the help messages.
341 if [ -z "$1" ] ; then
342 # This is currently invoked in all kinds of circumstances,
343 # including when the user made a usage error. Should we end up
344 # providing more than a short help message, then we should
346 # Petr's comment: http://marc.info/?l=git&m=122718711327376&w=2
348 ## Build available commands list for help output
352 for cmd
in "@cmddir@"/tg-
*; do
353 ! [ -r "$cmd" ] && continue
354 # strip directory part and "tg-" prefix
355 cmd
="$(basename "$cmd")"
361 echo "TopGit v$TG_VERSION - A different patch queue manager"
362 echo "Usage: tg [-r REMOTE] ($cmds|help) ..."
363 elif [ -r "@cmddir@"/tg-
$1 ] ; then
365 @cmddir@
/tg-
$1 -h 2>&1 ||
:
367 if [ -r "@sharedir@/tg-$1.txt" ] ; then
368 cat "@sharedir@/tg-$1.txt"
371 echo "`basename $0`: no help for $1" 1>&2
386 # Spawn pager process and redirect the rest of our output to it
391 # TG_PAGER = GIT_PAGER | PAGER | less
392 # NOTE: GIT_PAGER='' is significant
393 TG_PAGER
=${GIT_PAGER-${PAGER-less}}
395 [ -z "$TG_PAGER" -o "$TG_PAGER" = "cat" ] && return 0
399 export LESS
="${LESS:-FRSX}" # as in pager.c:pager_preexec()
401 # setup_pager should be called only once per command
402 pager_fifo
="$tg_tmp_dir/pager"
403 mkfifo -m 600 "$pager_fifo"
405 "$TG_PAGER" < "$pager_fifo" &
406 exec > "$pager_fifo" # dup2(pager_fifo.in, 1)
408 # this is needed so e.g. `git diff` will still colorize it's output if
409 # requested in ~/.gitconfig with color.diff=auto
410 export GIT_PAGER_IN_USE
=1
412 # atexit(close(1); wait pager)
413 # deliberately overwrites the global EXIT trap
414 trap "exec >&-; rm -rf \"$tg_tmp_dir\"; wait" EXIT
418 # creates a new temporary file (or directory with -d) in the global
419 # temporary directory $tg_tmp_dir with pattern prefix NAME
422 mktemp
${2-} "$tg_tmp_dir/$1.XXXXXX"
428 die
"No command directory: '@cmddir@'"
433 git_dir
="$(git rev-parse --git-dir)"
434 root_dir
="$(git rev-parse --show-cdup)"; root_dir
="${root_dir:-.}"
435 # Make sure root_dir doesn't end with a trailing slash.
436 root_dir
="${root_dir%/}"
437 base_remote
="$(git config topgit.remote 2>/dev/null)" ||
:
439 # make sure merging the .top* files will always behave sanely
441 setup_hook
"pre-commit"
442 # create global temporary directories, inside GIT_DIR
443 tg_tmp_dir
="$(mktemp -d "$git_dir/tg-tmp.XXXXXX
")"
444 trap "rm -rf \"$tg_tmp_dir\"" EXIT
448 # We were sourced from another script for our utility functions;
449 # this is set by hooks. Skip the rest of the file. A simple return doesn't
450 # work as expected in every shell. See http://bugs.debian.org/516188
451 if [ -z "$tg__include" ]; then
453 if [ "$1" = "-r" ]; then
456 echo "Option -r requires an argument." >&2
460 base_remote
="$1"; shift
461 tg
="$tg -r $base_remote"
465 [ -n "$cmd" ] ||
{ do_help
; exit 1; }
476 [ -r "@cmddir@"/tg-
$cmd ] ||
{
477 echo "Unknown subcommand: $cmd" >&2
481 .
"@cmddir@"/tg-
$cmd;;